// note - "#" = Alt + 3 (not printed on key!!!!)

// Import the interfaces
#import "HelloWorldLayer.h"
#import "SimpleAudioEngine.h"
#import "iCadeReaderView.h"
#import "levels.h"

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Basic Settings for Engine
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


#define MostImages 200        // max number of different images loaded in at once.
#define MaxSprites 200       // number of DrawImg's onscreen at once.

#define MostBatches 2        // Most batches the game can do.
#define MaxBatch 150         // Most images within each batch.

#define MaxText 10           // Most text batches onscreen at once.

// These default settings are alright!
// If you're using BIG images, scale the default values down a bit.
// If you want more LITTLE images, you can bang the numbers up a bit.
// For general purpose stuff, defaults are fine.

// Additional note about FramesPerSecond.

// I've set the PerFrame loop, and the Animation to be 45fps.
// This seems an odd number, but it's a nice midpoint.

// It LOOKS like it's going nice and fast, so most people will happily assume it's 60fps, and be none the wiser... (See SpikeDislike)
// Even if your game gets super busy, you won't actually SEE a framerate drop.
// It's only once it gets below 45fps that a little stuttering starts.
// Neato!

// If you'd rather your game is at 30 or 60 fps, do the following two steps.

// 1. Right at the bottom of the -(void) init function, (bottom of this file, then up a tiny bit) you'll find the first bit.
// [self schedule:@selector(perFrame) interval:(1.0f / 45.0f)];  <-- Change that to whatever your new fps is.

// 2. In AppDelegate.m, hunt for ...
// [director setAnimationInterval:1.0/45]; <-- Change that, too.

// I'm actually not 100% sure what the animation interval does, and am probably right in saying it's for pre-made anim things..
// but it doesn't hurt to be sure!




// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Your Variables start here.
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

//int ang;
int m;
float scrx;
//int World;


float HoldX;
float HoldY;
float AimX;
float AimY;
float Spd;

int Grid[250];

BOOL joystickUp;
BOOL joystickDown;
BOOL joystickLeft;
BOOL joystickRight;
BOOL joystickButtonA;
BOOL joystickButtonB;
BOOL joystickButtonC;
BOOL joystickButtonD;
BOOL joystickButtonE;
BOOL joystickButtonF;
BOOL joystickButtonG;
BOOL joystickButtonH;


int tileSize = 32;
int levWidth=64;
int levHeight=64;
int chipsRequired=0;
int levNum=0;
int maxLev = (sizeof(allLevels)/4097)-1;

int playerX;
int playerY;
int numChips = 0;
int scrollX=0;
int scrollY=0;
int playerD = 0; // direction
int playerF = 0;
int playerLives = 5;
int lastDirection=0;
int walking = 0;
int steps = 0;
int pathEdit=0;
int numEnemies=0;
int numBoxes=0;
int numButtons=0;



void loadLevel(lev){

	
    numChips=0;
    //items[8] = {0,0,0,0,0,0,0,0};
	chipsRequired = allLevels[(lev*((levHeight*levWidth)+1))+(levHeight*levWidth)];
	pathEdit = allDirMaps[(lev*((levHeight*levWidth)+1))+(levHeight*levWidth)];
    lastDirection = -1;
    
    int t=0;
    for(int y=0; y<levHeight; y++){
		for(int x=0; x<levWidth; x++){
			curLevel[t] = allLevels[(lev*((levHeight*levWidth)+1))+t];
			dirLevel[t] = allDirMaps[(lev*((levHeight*levWidth)+1))+t];
			// start position
			if(curLevel[t] == 20){ // start pos
				curLevel[t] = 0;
				playerX = tileSize * x +(tileSize/2);
				playerY = tileSize * y +(tileSize/2);
			}
            t++;
        }
    }
};

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Internal number stuffs
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

NSMutableArray *imgs;
NSMutableArray *objs;
NSMutableArray *objBatch;
NSMutableArray *sfx;
NSMutableArray *fonts;

int mx[15],my[15],md[15],mudown[15],mdAll,mudownAll;
float AccelX,AccelY;
int OrientationUse,OrientationIs;
int touchCount;

int Paused;
float PauseDark;
int PauseTicks;

int imgw[MostImages],imgh[MostImages],imgx[MostImages],imgy[MostImages],imga[MostImages];
int Loader=0;

int Set[40];

int LastSprite=MaxSprites;
int TopSprite=0;

int LastBatch[MostBatches];
int TopBatch[MostBatches];
int BatchIs[MostBatches];
int ChangeBatch=-1;
int ChangeBatchTo[MostBatches];
int ChangeBatchZ[MostBatches];


int LastText=20;
int TopText=0;

float ScaleUp=1;
int MaxSize=8;
int scaleTo,isPad,isHD;
int J_Col_R,J_Col_G,J_Col_B;
int J_Alpha;
int J_BlendA,J_BlendB;
int jscrw,jscrh,jscrh2;
float J_Rot,J_ScaleX,J_ScaleY;

int GameMode,GameType,GameLevel;
int Level,Score;
int MenuPick;


// Image Loading Flags
#define Plain 0
#define NoAlpha 1
#define OnlyAlpha 2
#define LowRGB 4


// HelloWorldLayer implementation
@implementation HelloWorldLayer

// Right after the implementation section
@synthesize tileMap = _tileMap;
@synthesize background = _background;

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	HelloWorldLayer *layer = [HelloWorldLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Touchy
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Touch Stuff


- (void)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
		//code here
        CGPoint location = [touch locationInView: [firsttouch view]];
        mx[touchCount+1]=location.x/scaleTo;
        my[touchCount+1]=location.y/scaleTo;
        md[touchCount+1]=1;
        touchCount++;
        }
	}
}


- (void)ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
		//code here
        CGPoint location = [touch locationInView: [firsttouch view]];
//        location = [[CCDirector sharedDirector] convertToGL: location];
        mx[touchCount+1]=location.x/scaleTo;
        my[touchCount+1]=location.y/scaleTo;
        md[touchCount+1]=1;
        touchCount++;
        }
	}
}


- (void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;    
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
            CGPoint location = [touch locationInView: [firsttouch view]];
            mx[touchCount+1]=location.x/scaleTo;
            my[touchCount+1]=location.y/scaleTo;
            md[touchCount+1]=1;
            for (UITouch *touchb in touches) {
                if (touchb==touch) {md[touchCount+1]=0;}
            }
            touchCount++;
        }
	}
}

#define kFilterFactor 0.05
- (void)accelerometer:(UIAccelerometer*)accelerometer didAccelerate:(UIAcceleration*)acceleration{    
    OrientationIs=[[UIDevice currentDevice] orientation];
    
    // Comment/Uncomment the following to allow for different orientations.
    

    // Landscape - Button on Right
    if (OrientationIs==3) {OrientationUse=3;}
    if (OrientationUse==3) {
        AccelX = acceleration.y;
        AccelY = acceleration.x;
    }
    // Landscape - Button on Left
    if (OrientationIs==4) {OrientationUse=4;}
    if (OrientationUse==4) {
        AccelX = -acceleration.y;
        AccelY = -acceleration.x;
    }

    /*
    // Portrait
    if (OrientationIs==1) {OrientationUse=1;}
    if (OrientationUse==1) {
        AccelX = acceleration.x;
        AccelY = acceleration.y;
    }
    // Portrait - Upside Down
    if (OrientationIs==2) {OrientationUse=2;}
    if (OrientationUse==2) {
        AccelX = -acceleration.x;
        AccelY = -acceleration.y;
    }
    */
    
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Standard stuff
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Standard Stuff


int rnd(int max) {return arc4random()%(max+1);}
int rnd_minmax(int min,int max) {return (arc4random()%((max-min)+1))+min;}

float rndf(int max) {return arc4random()%(max+1);}
float rndf_minmax(int min,int max) {return (arc4random()%((max-min)+1))+min;}


int MouseIn(float x,float y,float w,float h) {
    int fout=0;
    w--;h--;
    for (int n=1;n<11;n++) {
        if (mx[n]>x && mx[n]<x+w && my[n]>y && my[n]<y+h && md[n]==1) {fout=n;}
    }
    return fout;
}
int MouseIn_Centered(float x,float y,float w,float h) {
    int fout=0;
    w--;h--;
    x=x-w/2;y=y-h/2;
    for (int n=1;n<11;n++) {
        if (mx[n]>x && mx[n]<x+w && my[n]>y && my[n]<y+h && md[n]==1) {fout=n;}
    }
    return fout;
}


float dsin(float fn) {return sin(fn*0.0174532925);}
float dcos(float fn) {return cos(fn*0.0174532925);}



void SetTo(int SetThis,int SetTo) {
    if (SetThis>-1 && SetThis<15) {
        Set[SetThis]=SetTo;
        NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
        [standardUserDefaults setInteger:Set[SetThis] forKey:[NSString stringWithFormat:@"Settings%d",SetThis]];
        [standardUserDefaults synchronize];
    }
}


void SaveString(NSString *Ident,NSString *Value) {
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    [standardUserDefaults setObject:Value forKey:Ident];
    [standardUserDefaults synchronize];
}
NSString*LoadString(NSString *Ident) {
    NSString *tempstr=[[NSUserDefaults standardUserDefaults] stringForKey:Ident];
    return tempstr;
}

void SaveInt(NSString *Ident,int Value) {
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    [standardUserDefaults setInteger:Value forKey:Ident];
    [standardUserDefaults synchronize];
}
int LoadInt(NSString *Ident) {
    int tempint=[[NSUserDefaults standardUserDefaults] integerForKey:Ident];
    return tempint;
}


// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Handy Stuff
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark Handy Stuff

void Goto_URL(NSString *URL) {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:URL]];
    
}
void Goto_iTunes_App(int AppID) {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://itunes.apple.com/app/id%d?mt=8",AppID]]];
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Drawing
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark Drawing/Image Stuff

void LoadImage(NSString *filename, int imagenum, int fx,int fy,int flags)  {
    if (imagenum>-1 && imagenum<MostImages) {
        [CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGBA8888];
        if (flags==NoAlpha) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGB565];}
        if (flags==OnlyAlpha) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_A8];}
        if (flags==LowRGB) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGBA4444];}
        
        CCTexture2D *texture=[[CCTextureCache sharedTextureCache] addImage:filename]; 
        [imgs replaceObjectAtIndex:imagenum withObject:texture];
        
        
        imgx[imagenum]=fx;
        imgy[imagenum]=fy;
        imgw[imagenum]=(texture.contentSizeInPixels.width/CC_CONTENT_SCALE_FACTOR())/fx;
        imgh[imagenum]=(texture.contentSizeInPixels.height/CC_CONTENT_SCALE_FACTOR())/fy;
    }
}




void MakeArrays(){
    CCTexture2D *texture=[[CCTextureCache sharedTextureCache] addImage:@"Icon.png"];
    for (int n=0;n<MostImages;n++) {
        [imgs addObject:texture];
        imgx[n]=1;imgy[n]=1;
        imgw[n]=8;imgh[n]=8;
    }
}

-(void)ChangeBatches {
    
    for (int n=0;n<MostBatches;n++) {
        if (BatchIs[n]>-1) {
            CCSpriteBatchNode* QuickBatchb=(CCSpriteBatchNode*) [objBatch objectAtIndex:n*(MaxBatch+1)];
            [self removeChild:QuickBatchb cleanup:YES];
        }
    }
    [objBatch removeAllObjects];
    
    for (int n=0;n<MostBatches;n++) {
         BatchIs[n]=ChangeBatchTo[n];
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:ChangeBatchTo[n]];    
        // Batch
        CCSpriteBatchNode* QuickBatch = [CCSpriteBatchNode batchNodeWithTexture:txture];
        [objBatch addObject:QuickBatch];

        for (int zee=0;zee<MaxBatch;zee++) {
            CCSprite *sprite = [CCSprite spriteWithTexture:txture rect:CGRectMake(0,0,imgw[ChangeBatchTo[n]],imgh[ChangeBatchTo[n]])];
            [sprite.texture setAliasTexParameters];
            sprite.color=ccc3(255,255,255);
            sprite.scale=scaleTo;
            sprite.position = ccp(-512,-512);
            [QuickBatch addChild:sprite];
            [objBatch addObject:sprite];
        }
        [self addChild:QuickBatch];
        [self reorderChild:QuickBatch z:ChangeBatchZ[n]];
   }
    ChangeBatch=-1;
}


void SetAlpha(int fa) {if (fa<0) {fa=0;} if (fa>255) {fa=255;} J_Alpha=fa;}
void SetBlend(int fa) {
    switch (fa){
        case 1:  J_BlendA=GL_ONE;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 2:  J_BlendA=GL_ZERO;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 3:  J_BlendA=GL_DST_COLOR;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 4:  J_BlendA=GL_DST_COLOR;J_BlendB=GL_ONE; break;

        default: J_BlendA=GL_ONE;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
    }    
}

void SetCol(int fr,int fg,int fb) {
    if (fr<0) {fr=0;} if (fr>255) {fr=255;} J_Col_R=fr;
    if (fg<0) {fg=0;} if (fg>255) {fg=255;} J_Col_G=fg;
    if (fb<0) {fb=0;} if (fb>255) {fb=255;} J_Col_B=fb;
}

void SetRot(float fa) {J_Rot=fa;}
void SetSize(float fx) {J_ScaleX=fx;J_ScaleY=fx;}
void SetSizeXY(float fx, float fy) {J_ScaleX=fx;J_ScaleY=fy;}


void DrawBatch(int batch,float fx,float fy,int frame) {
    int fi=BatchIs[batch];
    
    if (batch>-1 && batch<MostBatches) {
    if (TopBatch[batch]>-1 && TopBatch[batch]<MaxBatch) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        
        CCSprite *gridSprite = (CCSprite *) [objBatch objectAtIndex:((MaxBatch+1)*batch)+1+TopBatch[batch]];            
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopBatch[batch]++;
    }
    }
}


void DrawImg(int fi,float fx,float fy,int frame) {
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
}


void DrawImgTile(int fi,float fx,float fy,float fw,float fh) {
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;     
        
        ccTexParams params = {GL_NEAREST, GL_NEAREST, GL_REPEAT, GL_REPEAT};
        [gridSprite.texture setTexParameters: &params];
         [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(0,0,fw,fh)];
        TopSprite++;
    }
}



int Clickable(int fi,float fx,float fy,int frame) {
    int inside=-1;
    float tfy=fy;
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        int uw=(imgw[fi]/2)*J_ScaleX;
        int uh=(imgh[fi]/2)*J_ScaleY;
        
        inside=MouseIn(fx-uw,tfy-uh,uw*2,uh*2);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        gridSprite.opacity=J_Alpha;
        if (inside>0) {gridSprite.opacity=J_Alpha/2;gridSprite.color=ccc3(J_Col_R/2,J_Col_G/2,J_Col_B/2);}
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
    return inside;
}

void Text(float fx, float fy,NSString *ftxt,float mid) {
    mid=mid/2;
    if (TopText>-1 && TopText<MaxText) {
        fy=jscrh2-(fy*scaleTo);
        CCLabelAtlas *labelb = (CCLabelAtlas *) [fonts objectAtIndex:TopText];
        [labelb setAnchorPoint: ccp(mid,1-mid)];
        labelb.position = ccp(fx*scaleTo,fy);
        labelb.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        labelb.opacity=J_Alpha;
        labelb.rotation=J_Rot;
        labelb.scaleX=J_ScaleX*scaleTo;
        labelb.scaleY=J_ScaleY*scaleTo;
        [labelb setString:ftxt];
        TopText++;
    }
}

void ResetDraw(){
    //-(void) ResetDraw {
    J_ScaleX=1;J_ScaleY=1;J_Rot=0;
    J_Alpha=255;J_Col_R=255;J_Col_B=255;J_Col_G=255;
}


-(void) Flip {
    for (int zee=TopSprite;zee<LastSprite;zee++) {
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:zee];
        gridSprite.position = ccp(-512,-512);
        [gridSprite setTextureRect:CGRectMake(0,0,1,1)];
    }
    LastSprite=TopSprite;
    TopSprite=0;
    
    for (int n=0;n<MostBatches;n++) {
       for (int zee=TopBatch[n];zee<LastBatch[n];zee++) {
            CCSprite *gridSprite = (CCSprite *) [objBatch objectAtIndex:((MaxBatch+1)*n)+1+zee];
            gridSprite.position = ccp(-512,-512);
            [gridSprite setTextureRect:CGRectMake(0,0,1,1)];
        }
        LastBatch[n]=TopBatch[n];
        TopBatch[n]=0;
    }
    
    
    for (int zee=TopText;zee<MaxText;zee++) {    
        CCLabelAtlas *labelb = (CCLabelAtlas *) [fonts objectAtIndex:zee];
        labelb.position = ccp(-512,-512);
        [labelb setString:[NSString stringWithFormat:@"" ]];
    }
    
    LastText=TopText;
    TopText=0;
    ResetDraw();
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Audio
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Audio Stuff


//  Top bit..  ---
void PlaySFX(int sfxN,float Pitch,float Volume,float Pan) {
NSString*sfxName=[NSString stringWithFormat:@"%03d.wav",sfxN];
//  Top bit..  ---
   
    //  All my sound effects, since about 2010, and probably before that
    //  have had a simple "nnn.wav" filename system,
    //  so I just made the PlaySFX follow that pattern.
    //  If you're going to be naming your sfx's properly, switch the top bit for the bottom!

//  Bottom bit.. ---
//void PlaySFX(NSString*sfxName,float Pitch,float Volume,float Pan) {
//  Bottom bit.. ---
    
    if (Set[5]==0) {[[SimpleAudioEngine sharedEngine] playEffect:sfxName pitch:Pitch pan:Pan gain:Volume];}
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  My Functions
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark My Functions

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Ingame : A set of constant onscreen elements that should always be there
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Ingame Elements

int pausedTime = 0;
// t = time, b = start, c = end, d = duration
int easeInOutQuad(float t, float b, float c, float d) {
	if ((t/=d/2) < 1) return c/2*t*t + b;
	return -c/2 * ((--t)*(t-2) - 1) + b;
}

int py;
+(void) PauseNow{ // This happens whenever something else on the iPhone tries to do something.
                    // ie, we AutoPause whenever one of those stupid alerts pop up right over the top of the fucking screen, in a really annoying way!
    Paused=25;
    pausedTime = 0;
    py = 0;
}

-(void) PauseMenu{
    pausedTime++;
    //int py=(jscrh/2)-((25-abs(Paused))*10);
    if(pausedTime <= 45) py = easeInOutQuad(pausedTime, 0, jscrh/2, 45);
    ResetDraw();
    DrawImg(48,jscrw/2,py,0);
    
    SetCol(255,255,255);
    int pbutton=Clickable(49,jscrw/2,py,3);
    if (pbutton>0 && mudown[pbutton]==0 && Paused==25) {mudown[pbutton]=1;Paused=-26;}

    //unpause button
    SetCol(255,0,0);
    pbutton=Clickable(49, jscrw/2-95,py-64, 4);
    if (pbutton>0 && mudown[pbutton]==0 && Paused==25) {mudown[pbutton]=1;Paused=0;GameMode=50;}
    
    ResetDraw();
    SetCol(100,255,100); if (Set[5]==1) {SetCol(255,100,100);}
    pbutton=Clickable(49,jscrw/2+95,py-64,1+Set[5]);
    if (pbutton>0 && mudown[pbutton]==0) {mudown[pbutton]=1;SetTo(5,1-Set[5]);}
    
    
}


-(void) Ingame {
    ResetDraw();
    if (Paused==0) {
        DrawImg(49,16,16,0);
        int pbutton=MouseIn(0,0,32,32);
        if (pbutton>0 && mudown[pbutton]==0 && Paused==0) {mudown[pbutton]=1;Paused=2; pausedTime = 0; py = 0;}
        if (joystickButtonG){mudown[pbutton]=1;Paused=2; pausedTime = 0; py = 0;}
    }
    
    if (Paused!=0) {
        Paused=Paused+2;if (Paused>25) {Paused=25;}
        PauseDark=1;
        [self PauseMenu];
        
        PauseDark=100-(abs(Paused)*3);
        PauseDark=PauseDark/100;
    }
}

void StartGame() {
    Score=0; Level  = 0;
    loadLevel(0);
    
    GameMode=10;

}
-(void)GameEnded{
    
    GameMode=0;
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Main Menu
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Main Menu

-(void) MainMenu {
    
    // Mute Button, top left.
    ResetDraw();
    SetCol(100,255,100); if (Set[5]==1) {SetCol(255,100,100);}
    DrawImg(49,16,16,1+Set[5]);
    int pbutton=MouseIn(0,0,32,32);
    if (pbutton>0 && mudown[pbutton]==0) {mudown[pbutton]=1;SetTo(5,1-Set[5]);}
    
    
    // Your Buttons.
    ResetDraw();
    int a=Clickable(1, jscrw*.4,jscrh*.25,0);
    if (a>0 && mudown[a]==0) {mudown[a]=1;PlaySFX(1,1,1,0);StartGame();}
    if(joystickButtonA){mudown[a]=1;PlaySFX(1,1,1,0);StartGame();}

}


- (void)buttonDown:(iCadeState)button {
    [self setState:YES forButton:button];
}

- (void)buttonUp:(iCadeState)button {
    [self setState:NO forButton:button];
}

- (void)setState:(BOOL)state forButton:(iCadeState)button {
    switch (button) {
        case iCadeJoystickUp:       if (state) { joystickUp = YES; } else { joystickUp = NO; } break;
        case iCadeJoystickDown:     if (state) { joystickDown = YES; } else { joystickDown = NO; } break;
        case iCadeJoystickLeft:     if (state) { joystickLeft = YES; } else { joystickLeft = NO; } break;
        case iCadeJoystickRight:    if (state) { joystickRight = YES; } else { joystickRight = NO; } break;
        case iCadeButtonA: if(state){ joystickButtonA = YES; }else{ joystickButtonA = NO; } break;
        case iCadeButtonB: if(state){ joystickButtonB = YES; }else{ joystickButtonB = NO; } break;
        case iCadeButtonC: if(state){ joystickButtonC = YES; }else{ joystickButtonC = NO; } break;
        case iCadeButtonD: if(state){ joystickButtonD = YES; }else{ joystickButtonD = NO; } break;
        case iCadeButtonE: if(state){ joystickButtonE = YES; }else{ joystickButtonE = NO; } break;
        case iCadeButtonF: if(state){ joystickButtonF = YES; }else{ joystickButtonF = NO; } break;
        case iCadeButtonG: if(state){ joystickButtonG = YES; }else{ joystickButtonG = NO; } break;
        case iCadeButtonH: if(state){ joystickButtonH = YES; }else{ joystickButtonH = NO; } break;
        default:
            break;
    }
}



// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Game Stuff
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark PlayGame

-(void) PlayGame {
       
   // if(joystickButtonA)PlaySFX(1,1,1,0);


    if(walking == 0){
        if(joystickUp){
                steps=0;
                walking=1;
                playerD = 3;
                lastDirection = playerD;
        }
        if(joystickDown){
                steps=0;
                walking=1;
                playerD = 0;
                lastDirection = playerD;
        }
        if(joystickLeft){
                steps=0;
                walking=1;
                playerD = 1;
                lastDirection = playerD;
        }
        if(joystickRight){
                steps=0;
                walking=1;
                playerD = 2;
                lastDirection = playerD;
        }
    
}
    
    if(walking==1){
		if(playerD==0)playerY+=2;
		if(playerD==3)playerY-=2;
		if(playerD==2)playerX+=2;
		if(playerD==1)playerX-=2;
			if(steps %8 == 0)playerF++;
		if(playerF==4)playerF=0;
		steps++;
		if(steps>=tileSize/2){
			steps=0;
			walking=0;
		}
	}

    int screenX = playerX - (jscrw/2);
    int screenY = playerY - (jscrh/2);
    if(screenX < 0)screenX = 0;
    if(screenY < 0)screenY = 0;
    
    int scrollX = screenX % 32;
    int scrollY = screenY % 32;
    
    ResetDraw();
    for (int x=0; x<16; x++) {
        for (int y=0; y<11; y++) {
            int tile = curLevel[(x+(screenX/tileSize)) + levWidth * (y+(screenY/tileSize))];
            DrawImg(9,((x*tileSize)-scrollX+(tileSize/2)),(y*tileSize)-scrollY+(tileSize/2),tile);
        }
    }

    
    ResetDraw();
    DrawImg(8,(playerX)-screenX,(playerY)-screenY,playerF+4*playerD);

    
    //Score++;
    ResetDraw();
    SetCol(100,255,100);
    Text(jscrw/2,16,[NSString stringWithFormat:@"%08d",Score],1);
    
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Main Loop / Loader
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Main Background Loop / Loader

-(void) perFrame {
    if (Paused==0) {PauseDark=1;}
    if (Loader==0) {
        if (GameMode==0) {[self MainMenu];Paused=0;}
        if (GameMode==10){
            if(Paused==0)[self PlayGame];
            [self Ingame];
        }
        if (GameMode==50) {[self GameEnded];}
    }

    
    if (Loader>0) {
 
        switch (Loader) {
                
            case 1:
                LoadImage(@"BasicIcons.png",49,3,3,LowRGB);  // These are your pause/mute/etc icons.
                
                LoadImage(@"Buttons.png",1,2,2,Plain);  // Plain : Will load images as 32 bits per pixel.  crikey!
                break;
            case 2:
                LoadImage(@"Paused.png",48,1,1,Plain);  // This is the big Pause background thing.

            case 3:
                LoadImage(@"Blocks.png",3,4,4,LowRGB);  // LowRGB : Uses 4 bits per pixel instead of 8, keeps all channels.  Saves 1/2 memory!
                break;
            case 4:
              //  LoadImage(@"GotoSite.png",4,1,1,LowRGB);
                break;
                
            case 5:
                LoadImage(@"BG_Grid.png",5,1,1,NoAlpha);    // NoAlpha : Reduces bits per pixel, and strips Alpha.  About 2/3's, give or take.
                break;
                
            case 6:
             //   LoadImage(@"BG_Grid.png",6,2,2,NoAlpha);       //  Although, it should be noted..  I'm only assuming Cocos2D actually does do that!!!
             //   SetBatch(1,2,2); // Batch#, Use Image#, ZOrder : 0 = right at the back.  If you want the first image behind it, go 1, etc,etc..
             //   SetBatch(0,6,1);                            //   500 would always be at the front.. .. unless you can somehow handle >500 sprites!!
                break;
                
            case 7:
               // LoadImage(@"Gradient.png",7,1,1,NoAlpha);
                break;
            case 8:
                LoadImage(@"hero.png",8,4,4,Plain);
                break;
            case 9:
                LoadImage(@"tiles.png",9,1,44,NoAlpha);
                break;

            default:
                Loader=-1;
                break;
        }
        Loader++;
    }
    
    
    // Leave these bits!
    if (ChangeBatch>-1) {[self ChangeBatches];ChangeBatch=-1;}
    mdAll=0;
    for (int n=0;n<15;n++) {if (md[n]==1) {mdAll=1;} if (md[n]==0) {mudown[n]=0;}}
    if (mdAll==0) {mudownAll=0;}
    [self Flip];
}



// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Init
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Init



// on "init" you need to initialize your instance
-(id) init
{
    
    
 	if ((self = [super init])) {    
        iCadeReaderView *icrv = [[iCadeReaderView alloc] initWithFrame:CGRectZero];
        EAGLView *root = [[CCDirector sharedDirector] openGLView];
        [root addSubview:icrv];
        icrv.active = YES;
        icrv.delegate = self;
    }
    
    for (int n=0;n<MostBatches;n++) {
        BatchIs[n]=-1;
        LastBatch[n]=MaxBatch;
   }
    imgs=[[NSMutableArray alloc] init];
    objs=[[NSMutableArray alloc] init];
    objBatch=[[NSMutableArray alloc] init];
    sfx=[[NSMutableArray alloc] init];
    fonts=[[NSMutableArray alloc] init];

    GameMode=0;
    for (int n=0;n<15;n++) {
		Set[n]=[[NSUserDefaults standardUserDefaults] integerForKey:[NSString stringWithFormat:@"Settings%d",n]];
		Set[n+15]=-1;
	}
    SetBlend(1);
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super initWithColor:ccc4(0,0,40,255)] )) {
        
        CGSize size = [[CCDirector sharedDirector] winSize];
        isPad=0;
        scaleTo=1;ScaleUp=1;
        if (size.width==1024 && size.height==768) {isPad=1;scaleTo=2;ScaleUp=1.066666666666667;}
        if (size.height==1024 && size.width==768) {isPad=1;scaleTo=2;ScaleUp=1.066666666666667;}
        
        // scaleTo
            // This is used internally.  All drawing gets scaled by this value.
            // Basically, if you play on an iPad, everything's 2* bigger.
            // If you'd rather it didn't, make it 1!
        
        // ScaleUp
            // Since the 2*Bigger scale doesn't quite fit the whole of an iPad's screen,
            // you can use ScaleUp to multiply your tiles/grids to fill the whole of the iPad's screen.
            //  Quirky, but works.. kinda..
            // Just don't forget to test it, and scale your graphics up to fit.
            //  Probably best just to overscan things, though.  That works better!
        
        jscrw=size.width/scaleTo;
        jscrh=size.height/scaleTo;
        jscrh2=size.height;
        
        
        // Load Fonts
        for (int zee=0;zee<MaxText;zee++) {
            CCLabelAtlas *labelb = [CCLabelAtlas labelAtlasWithString:@" " charMapFile:@"16_(9x17).png" itemWidth:9 itemHeight:17 startCharMap:32];
            [labelb setAnchorPoint: ccp(0.5f, 0.5f)];
            labelb.position = ccp(-512,-512);
            labelb.color=ccc3(255,255,255);
            [self addChild:labelb];
            [self reorderChild:labelb z:500];
            [fonts addObject:labelb];
        }

        MakeArrays();
        [self ChangeBatches];

        CCTexture2D *texture= (CCTexture2D *) [imgs objectAtIndex:0];
        // Sprites
        for (int zee=0;zee<MaxSprites;zee++) {
            CCSprite *sprite = [CCSprite spriteWithTexture:texture rect:CGRectMake(0,0,MaxSize,MaxSize)];
            sprite.color=ccc3(255,255,255);
            sprite.scale=scaleTo;
            sprite.position = ccp(-512,-512);
            [self addChild:sprite];
            [self reorderChild:sprite z:zee+1];
            [objs addObject:sprite];
        }



        Loader=1;
        
       [[SimpleAudioEngine sharedEngine] playEffect:@"sfx_003.caf"];
	}
    GameType=1;
    OrientationUse=3; // You want to define this at the start, otherwise if the player starts whilst the device is flat, it goes a bit odd!
    
    self.isTouchEnabled = YES;
	self.isAccelerometerEnabled = NO;
	[[UIAccelerometer sharedAccelerometer] setUpdateInterval:(1.0 / 30)];
    
    GameType=0;


	[self schedule:@selector(perFrame) interval:(1.0f / 45.0f)]; 
	return self;
}





// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)

    
	// don't forget to call "super dealloc"
	[super dealloc];
}
@end
